#---
# Excerpted from "Agile Web Development with Rails"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com for more book information.
#---
$: << File.dirname(__FILE__)
require "connect"
require "logger"
require "rubygems"
require_gem "activerecord"

#ActiveRecord::Base.logger = Logger.new(STDOUT)


class Parent < ActiveRecord::Base
  has_many :children, :order => :position
end

class Child < ActiveRecord::Base
  belongs_to :parent
  acts_as_list  :scope => :parent_id
end


Child.delete_all
Parent.delete_all


parent = Parent.new
%w{ One Two Three Four}.each do |name|
  parent.children.create(:name => name)
end
parent.save



def display_children(parent)
  puts parent.children.map {|child| child.name }.join(", ")
end



display_children(parent)         #=> One, Two, Three, Four

puts parent.children[0].first?   #=> true

two = parent.children[1]
puts two.lower_item.name         #=> Three
puts two.higher_item.name        #=> One

parent.children[0].move_lower
parent.reload
display_children(parent)         #=> Two, One, Three, Four

parent.children[2].move_to_top
parent.reload
display_children(parent)         #=> Three, Two, One, Four

parent.children[2].destroy
parent.reload
display_children(parent)         #=> Three, Two, Four

