#---
# Excerpted from "Agile Web Development with Rails"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com for more book information.
#---
$: << File.dirname(__FILE__)
require "connect"
require "logger"

#ActiveRecord::Base.logger = Logger.new(STDOUT)

require "rubygems"
require_gem "activerecord"



class Product < ActiveRecord::Base
  has_many :line_items
end


class LineItem < ActiveRecord::Base
  belongs_to :product
end

LineItem.delete_all

p = Product.create(:title => "Programming Ruby", :date_available => Time.now)
l = LineItem.new
l.id = 2
l.product = p
l.save!

l = LineItem.new
l.product = p
l.save!


item = LineItem.find(2)

# item.product is the associated Product object
puts "Current product is #{item.product.id}"
puts item.product.title

item.product = Product.new(:title          => "Advanced Rails",
                           :description    => "...",
                           :image_url      => "http://....jpg",
                           :price          => 34.95,
                           :date_available => Time.now)
item.save!

puts "New product is #{item.product.id}"
puts item.product.title



item = LineItem.find(2)

# item.product is the associated Product object
puts "Current product is #{item.product.id}"
puts item.product.title

item = LineItem.new()

item.create_product(:title          => "Advanced Rails", 
                    :description    => "...",
                    :image_url      => "http://....jpg",
                    :price          => 34.95,
                    :date_available => Time.now)

puts "New product is #{item.product.id}"
puts item.product.title

item.save!
p item.product(true)

puts "============="

prod = Product.find(item.product_id)
p prod.line_items.size

