#---
# Excerpted from "Agile Web Development with Rails"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com for more book information.
#---
$: << File.dirname(__FILE__)
require "connect"
require "logger"

#ActiveRecord::Base.logger = Logger.new(STDOUT)

require "rubygems"
require_gem "activerecord"


class Product < ActiveRecord::Base
  has_many :line_items
end


class LineItem < ActiveRecord::Base
  belongs_to :product, :counter_cache => true
end


LineItem.delete_all
Product.delete_all


product = Product.create(:title => "Programming Ruby",
                         :date_available => Time.now)

line_item = LineItem.new
line_item.product = product
line_item.save

puts "In memory size = #{product.line_items.size}"
puts "Refreshed size = #{product.line_items(:refresh).size}"




LineItem.delete_all
Product.delete_all


product = Product.create(:title => "Programming Ruby", 
                         :date_available => Time.now)
product.line_items.create

puts "In memory size = #{product.line_items.size}"
puts "Refreshed size = #{product.line_items(:refresh).size}"




