#---
# Excerpted from "Agile Web Development with Rails"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com for more book information.
#---
class Cart

  attr_reader :items
  attr_reader :total_price
  
  
  def initialize
    empty!
  end

  

  # add a product to our list of items. If an item already
  # exists for that product, up the count instead
  def add_product(product)
    item = @items.find {|i| i.product_id == product.id}
    if item
      item.quantity += 1
    else
      item = LineItem.for_product(product)
      @items << item
    end
    @total_price += item.unit_price
  end

  
  
  def empty!
    @items = []
    @total_price = 0.0
  end
  
  
end

