#---
# Excerpted from "Agile Web Development with Rails"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com for more book information.
#---
class Order < ActiveRecord::Base

  has_many :line_items

  PAYMENT_TYPES = [
    [ "Check",          "check" ], 
    [ "Credit Card",    "cc"    ],
    [ "Purchase Order", "po"    ]
  ].freeze

  validates_presence_of :name, :email, :address, :pay_type

  
  def self.pending_shipping
    find(:all, :conditions => "shipped_at is null")
  end
  


end

