#---
# Excerpted from "Agile Web Development with Rails"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com for more book information.
#---


class LoginController < ApplicationController


  layout "admin"  



  before_filter :authorize, :except => :login
  # . . 




  def index
    @total_orders = Order.count
    @pending_orders = Order.count_pending
  end


  # just display the form and wait for user to
  # enter a name and password
  
  def login
    if request.get?
      session[:user_id] = nil
      @user = User.new
    else
      @user = User.new(params[:user])
      logged_in_user = @user.try_to_login

      if logged_in_user
        session[:user_id] = logged_in_user.id
        redirect_to(:action => "index")
      else
        flash[:notice] = "Invalid user/password combination"
      end
    end
  end
  

  
  def add_user
    if request.get?
      @user = User.new
    else
      @user = User.new(params[:user])
      if @user.save
        redirect_to_index("User #{@user.name} created")
      end
    end
  end

  # . . .
  

  
  def delete_user
    id = params[:id]
    if id && user = User.find(id)
      begin
        user.destroy
        flash[:notice] = "User #{user.name} deleted"
      rescue       
        flash[:notice] = "Can't delete that user"
      end
    end
    redirect_to(:action => :list_users)
  end
  

  def list_users
    @all_users = User.find(:all)
  end

  
  def logout
    session[:user_id] = nil
    flash[:notice] = "Logged out"
    redirect_to(:action => "login")
  end
  
end
