#---
# Excerpted from "Agile Web Development with Rails"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com for more book information.
#---
class StoreController < ApplicationController
  
  def index
    @products = Product.salable_items
  end

  
  def add_to_cart
    product = Product.find(params[:id])
    @cart = find_cart
    @cart.add_product(product)
    redirect_to(:action => 'display_cart')
  end
  

  
  def display_cart
    @cart = find_cart
    @items = @cart.items
  end
  



  private



  # Return a cart object. If we already have one cached
  # in the session, use it, otherwise create a new one 
  # and add it to the session

  def find_cart
    session[:cart] ||= Cart.new
  end


end
