#---
# Excerpted from "Agile Web Development with Rails"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com for more book information.
#---

require File.dirname(__FILE__) + '/../test_helper'
require 'login_controller'

# Re-raise errors caught by the controller.
class LoginController; def rescue_action(e) raise e end; end

class LoginControllerTest < Test::Unit::TestCase
  


  fixtures :users


  def setup
    @controller = LoginController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new
  end

  # Replace this with your real tests.
  def test_truth
    assert true
  end


# This test won't pass!

  def test_index    
    get :index
    assert_response :success
  end



  def test_index_without_user
    get :index
    assert_redirected_to :action => "login"
    assert_equal "Please log in", flash[:notice]
  end



  def test_login_with_invalid_user
    post :login, :user => {:name => 'fred', :password => 'opensesame'}
    assert_response :success
    assert_equal "Invalid user/password combination", flash[:notice]
  end



  def test_login_with_valid_user
    post :login, :user => {:name => 'fred', :password => 'abracadabra'}
    assert_redirected_to :action => "index"
    assert_not_nil(session[:user_id])
    user = User.find(session[:user_id])
    assert_equal 'fred', user.name
  end

  
def test_login_with_valid_user_custom
  login
end


end

