#---
# Excerpted from "Agile Web Development with Rails"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com for more book information.
#---

require File.dirname(__FILE__) + '/../test_helper'
require 'search_controller'

class SearchControllerTest < Test::Unit::TestCase

  fixtures :products
  
  def setup
    @controller = SearchController.new
    @request = ActionController::TestRequest.new
    @response = ActionController::TestResponse.new
  end




  def test_search
    get :search, :query => "version control"
    assert_response :success


    assert_equal "Found 1 product(s).", flash[:notice]
    assert_template "search/results"


    products = assigns(:products)
    assert_not_nil products
    assert_equal 1, products.size
    assert_equal "Pragmatic Version Control", products[0].title


    assert_tag :tag => "div", 
               :attributes => { :class => "results" },
               :children => { :count => 1, 
                              :only => { :tag => "div", 
                                         :attributes => { :class => "catalogentry" }}}
             

  end



end

