#---
# Excerpted from "Agile Web Development with Rails"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com for more book information.
#---

require File.dirname(__FILE__) + '/../test_helper'
require 'store_controller'

class OrderTest < Test::Unit::TestCase



  fixtures :products



  HOW_MANY = 100



  def setup
    @controller = StoreController.new
    @request = ActionController::TestRequest.new
    @response = ActionController::TestResponse.new



    get :add_to_cart, :id => @version_control_book.id
  end
  
  def teardown
    Order.delete_all
  end



  def test_save_bulk_orders
      
    elapsedSeconds = Benchmark::realtime do
    
      Fixtures.create_fixtures(File.dirname(__FILE__) + 
                               "/../fixtures/performance", "orders")

      assert_equal(HOW_MANY, Order.find_all.size)

      1.upto(HOW_MANY) do |id|
        order = Order.find(id)
        get :save_order, :order => order.attributes
        assert_redirected_to :action => 'index'
        assert_equal("Thank you for your order.", flash[:notice])
      end
    
    end
    
    assert elapsedSeconds < 8.0, "Actually took #{elapsedSeconds} seconds"



  end

end
