#---
# Excerpted from "Agile Web Development with Rails"
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com for more book information.
#---


ENV["RAILS_ENV"] = "test"

require File.dirname(__FILE__) + "/../config/environment"
require 'application'

require 'test/unit'
require 'active_record/fixtures'
require 'action_controller/test_process'
require 'action_web_service/test_invoke'
require 'breakpoint'

def create_fixtures(*table_names)
  Fixtures.create_fixtures(File.dirname(__FILE__) + "/fixtures", table_names)
end


Test::Unit::TestCase.fixture_path = File.dirname(__FILE__) + "/fixtures/"





def assert_salable(product)
  assert(product.salable?, 
         "Product #{product.id} (#{product.title}) should be for sale")
end
 
def assert_not_salable(product)
  assert(!product.salable?, 
         "Product #{product.id} (#{product.title}) should not be for sale")
end



def assert_errors
  assert_tag error_message_field
end
 
def assert_no_errors
  assert_no_tag error_message_field
end
 
def error_message_field
  {:tag => "div", :attributes => { :class => "fieldWithErrors" }}
end 



def login(name='fred', password='abracadabra')
  post :login, :user => {:name => name, :password => password}
  assert_redirected_to :action => "index"
  assert_not_nil(session[:user_id])
  user = User.find(session[:user_id])
  assert_equal name, user.name, "Login name should match session name"
end

